
public class BenutzerVerwalterL {

  private int maxBenutzerzahl = 100;
  private int aktBenutzerzahl = 0;
  private int maxPIN = 0;
  private List<Benutzer> benutzerDaten;

  public BenutzerVerwalterL() {
    benutzerDaten = new List<Benutzer>();
  }

  public String gibVersion() {
    return "L: List, Sortieren  Kriterium Name/ Verbrauch/ PIN";
  }

  private String erzeugePIN() {
    int intervall = 15000/maxBenutzerzahl;
    int zufallszahl = (int) (Math.random()*intervall) + 1;
    maxPIN = maxPIN + zufallszahl;   
    String pin = "" + maxPIN;
    if (pin.length() == 1) {
      pin = "000"+pin;
    }
    if (pin.length() == 2) {
      pin = "00"+pin;
    }
    if (pin.length() == 3) {
      pin = "0"+pin;
    }
    return pin;
  }

  public void neuerBenutzer(String pName) {
    boolean vorhanden;
    String pin;
    Benutzer b = null;
    do {
      pin = erzeugePIN();
      if (aktBenutzerzahl > 0) {
        b = lineareSuchePIN(pin); 
      }
      if (b == null) {
        vorhanden = false; 
      } else {
        vorhanden = true;
      }
    } while (vorhanden); 
    if (!vorhanden) {
      eintragen(pName,pin);
      //System.out.println(pName+" "+pin+" anzahl: "+aktBenutzerzahl);
    }
  }

  public void beispielBelegung() {
    for (int i = 0; i < 25; i++) {
      neuerBenutzer("A"+i);
    }
    neuerBenutzer("T");
  }

  private int pinNr(String pPIN) {
    return Integer.parseInt(pPIN);
  }

  private void eintragen(String pName, String pPIN) {
    Benutzer neu = new Benutzer(pName,pPIN);
    int anzahl = (int) (Math.random()*1000);
    neu.erhoeheVerbrauch(anzahl);
    benutzerDaten.append(neu);  
    System.out.println(neu.gibName()+" "+neu.gibPIN());
    aktBenutzerzahl++;
  }

  private Benutzer lineareSucheName(String pName) {
    boolean gefunden = false;
    benutzerDaten.toFirst();
    while (gefunden == false && benutzerDaten.hasAccess()) {
      Benutzer b = benutzerDaten.getContent();
      if (b != null && b.gibName().equals(pName)) {
        gefunden = true;
      } else {
        benutzerDaten.next();
      }
    }
    if (benutzerDaten.hasAccess()) {
      return benutzerDaten.getContent();
    } else {
      return null;
    }
  }

  private Benutzer lineareSuchePIN(String pPIN) {
    boolean gefunden = false;
    boolean weiter = true;
    benutzerDaten.toFirst();
    while (gefunden == false && benutzerDaten.hasAccess()) {
      Benutzer b = benutzerDaten.getContent();
      if (b != null && b.gibPIN().equals(pPIN)) {
        gefunden = true;
      } else {
        benutzerDaten.next();
      }
      if (pPIN.compareTo(b.gibPIN()) < 0) {
        weiter = false;
      }
      weiter = weiter && !gefunden;
    }
    if (benutzerDaten.hasAccess()) {
      return benutzerDaten.getContent();
    } else {
      return null;
    }
  }

  public Benutzer sucheBenutzerPIN(String pPIN) {
    return lineareSuchePIN(pPIN);
  }

  public Benutzer sucheBenutzerName(String pName) {
    return lineareSucheName(pName);
  }

  public String erstelleAusgabe() {
    String ausgabe = "";
    benutzerDaten.toFirst();
    while (benutzerDaten.hasAccess()){
      Benutzer aktuell = benutzerDaten.getContent();
      String  zeile = "";    
      zeile = zeile + "  "+ aktuell.gibName();
      zeile = zeile + "\t "+ aktuell.gibAnzahl();
      ausgabe = ausgabe + zeile + "\n";
      benutzerDaten.next();
    }
    return ausgabe;
  }

  public void sortiereVerbrauch() {
    // Straight Selection, Anzahl der Kopien
    List<Benutzer> hilfsliste = new List<Benutzer>();
    while (!benutzerDaten.isEmpty()) {
      benutzerDaten.toFirst();
      Benutzer max = benutzerDaten.getContent();
      while (benutzerDaten.hasAccess()) {
        Benutzer aktueller = benutzerDaten.getContent();
        if (aktueller.gibAnzahl() > max.gibAnzahl()) {
          max = aktueller;
        }
        benutzerDaten.next();
      }
      benutzerDaten.toFirst();
      while (benutzerDaten.hasAccess()) {
        if (max == benutzerDaten.getContent()) {
          benutzerDaten.remove();
        }
        benutzerDaten.next();
      }
      hilfsliste.append(max);
    }
    benutzerDaten.concat(hilfsliste);
  }

  public void sortiereNamen() {
    // Straight Insertion, Name
    List<Benutzer> hilfsliste = new List<Benutzer>();
    benutzerDaten.toFirst();        
    while (!benutzerDaten.isEmpty()) {
      Benutzer aktueller = benutzerDaten.getContent();
      benutzerDaten.remove();
      hilfsliste.toFirst();
      boolean gefunden = false;
      while (!gefunden && hilfsliste.hasAccess()) {
        if (aktueller.gibName().compareTo(hilfsliste.getContent().gibName()) < 0) {
          gefunden = true;
        } else {
          hilfsliste.next();
        }
      }
      if (hilfsliste.hasAccess()) {
        hilfsliste.insert(aktueller);
      } else {
        hilfsliste.append(aktueller);
      }
    }
    benutzerDaten.concat(hilfsliste);
  }

  public void sortierePIN() {
    // Quicksort, PIN
    benutzerDaten = quicksort(benutzerDaten);
  }

  private List<Benutzer> quicksort(List<Benutzer> pListe) {
    List<Benutzer> ergebnis = new List<Benutzer>();
    if (!pListe.isEmpty()) {
      pListe.toFirst();
      Benutzer pivot = pListe.getContent();
      pListe.remove();
      List<Benutzer> kleiner = new List<Benutzer>();
      List<Benutzer> groesser = new List<Benutzer>();
      while (!pListe.isEmpty()) {
        Benutzer aktuelles = pListe.getContent();
        if (aktuelles.gibPIN().compareTo(pivot.gibPIN()) < 0) {
          kleiner.append(aktuelles);
        } else {
          groesser.append(aktuelles);
        }
        pListe.remove();
      }
      kleiner = quicksort(kleiner);
      groesser = quicksort(groesser);
      ergebnis = kleiner;
      ergebnis.append(pivot);
      ergebnis.concat(groesser);     
    }
    return ergebnis;
  }

}

