
public class BenutzerVerwalterA {

  private int maxBenutzerzahl = 100;
  private int aktBenutzerzahl = 0;
  private int maxPIN = 0;
  private Benutzer[] benutzerDaten;

  public BenutzerVerwalterA() {
    benutzerDaten = new Benutzer[maxBenutzerzahl];
    for (int i = 0; i < benutzerDaten.length; i++) {
      benutzerDaten[i] = null;
    }
  }

  public String gibVersion() {
    return "A: ARRAY, Suche PIN (binaer), Suche Name (sequentiell)";
  }

  private String erzeugePIN() {
    int intervall = 15000/maxBenutzerzahl;
    int zufallszahl = (int) (Math.random()*intervall) + 1;
    maxPIN = maxPIN + zufallszahl;   
    String pin = "" + maxPIN;
    if (pin.length() == 1) {
      pin = "000"+pin;
    }
    if (pin.length() == 2) {
      pin = "00"+pin;
    }
    if (pin.length() == 3) {
      pin = "0"+pin;
    }
    return pin;
  }

  public void neuerBenutzer(String pName) {
    boolean vorhanden;
    String pin;
    Benutzer b = null;
    do {
      pin = erzeugePIN();
      if (aktBenutzerzahl > 0) {
        b = suchePINseq(pin); 
      }
      if (b == null) {
        vorhanden = false; 
      } else {
        vorhanden = true;
      }
    } while (vorhanden); 
    if (!vorhanden) {
      eintragen(pName,pin);
      //System.out.println(pName+" "+pin+" anzahl: "+aktBenutzerzahl);
    }
  }

  public void beispielBelegung() {
    for (int i = 0; i < 25; i++) {
      neuerBenutzer("a"+i);
    }
    neuerBenutzer("Tester");
  }

  private int pinNr(String pPIN) {
    return Integer.parseInt(pPIN);
  }

  private void eintragen(String pName, String pPIN) {
    Benutzer neu = new Benutzer(pName,pPIN);
    benutzerDaten[aktBenutzerzahl] = neu;  

    System.out.println((aktBenutzerzahl)+" "+benutzerDaten[aktBenutzerzahl].gibName()+" "+benutzerDaten[aktBenutzerzahl].gibPIN());
    aktBenutzerzahl++;
  }

  public Benutzer sucheName(String pName) {
    boolean gefunden = false;
    int zaehler = 0;
    while (gefunden == false && zaehler < benutzerDaten.length) {
      if (benutzerDaten[zaehler] != null && benutzerDaten[zaehler].gibName().equals(pName)) {
        gefunden = true;
      } else {
        zaehler = zaehler + 1;
      }
    }
    if (zaehler < benutzerDaten.length) {
      return benutzerDaten[zaehler];
    } else {
      return null;
    }
  }

  private Benutzer suchePINseq(String pPIN) {
    boolean gefunden = false;
    int zaehler = 0;
    while (gefunden == false && zaehler < benutzerDaten.length) {
      if (benutzerDaten[zaehler] != null && benutzerDaten[zaehler].gibPIN().equals(pPIN)) {
        gefunden = true;
      } else {
        zaehler = zaehler + 1;
      }
    }
    if (zaehler < benutzerDaten.length) {
      return benutzerDaten[zaehler];
    } else {
      return null;
    }
  }

  private Benutzer suchePINBinaerI(String pSuchPIN) {
    int links, rechts, mitte, index;
    links = 0;
    rechts = aktBenutzerzahl;
    index = -1;
    while (links <= rechts && index < 0) {
      mitte = (rechts + links)/2; 
      if (benutzerDaten[mitte].gibPIN().equals(pSuchPIN)) {
        index = mitte;
      } else {
        if (benutzerDaten[mitte].gibPIN().compareTo(pSuchPIN) < 0) {
          links = mitte + 1;
        } else {         
          rechts = mitte - 1;
        }
      }
      System.out.println("links "+links+" rechts "+rechts+" mitte "+mitte);
    }
    if (index >= 0) {
      return benutzerDaten[index];
    } else {
      return null;
    }
  }

  public Benutzer suchePIN(String pSuchPIN) {
    return suchePINbinaerR(pSuchPIN, 0, aktBenutzerzahl-1);
  }

  private Benutzer suchePINbinaerR(String pSuchPIN, int pLinks, int pRechts) {
    if ((pLinks < 0) || (pRechts > aktBenutzerzahl) || (pLinks > pRechts) ) {
      return null;
    } else {
      int mitte = (pLinks + pRechts)/2;
      if (benutzerDaten[mitte].gibPIN().equals(pSuchPIN)) {
        return benutzerDaten[mitte];
      } else if (benutzerDaten[mitte].gibPIN().compareTo(pSuchPIN) > 0) {
        return suchePINbinaerR(pSuchPIN, pLinks, mitte-1);
      } else {
        return suchePINbinaerR(pSuchPIN, mitte+1, pRechts);
      }
    }
  }

}
